

function ran(min, max) {
  return Math.random() * (max - min) + min;
};


class SmokeStack {
  constructor(element) {
    this.element = element;
    this.rotation = 0;
    this.scale = parseFloat(element.dataset['scale']);
    
    this.element.style.opacity = 0;

    this.height = this.element.offsetHeight;
  }

  async start() {
    console.log(this.height, this.scale);

    while (true) {
      let duration = ran(10000, 20000);
      let delay = ran(0, 10000);

      let initialScale = ran(0.6, 1) * this.scale;
      let targetScale = ran(1, 2) * this.scale;

      // console.log(duration)
      await anime({
        targets: this.element,
        translateX: {
          value: [0, ran(0, 10)],
          duration: 800
        },
        
        translateY: {
          value: [ 500, - 500 ]
        },
        opacity: {
          value: [ 0, 1 ],
          duration: 500
        },
        rotate: {
          value: [ ran(-5, 5), ran(-5, 5) ],

        },
        scale: {
          value: [ initialScale, targetScale ]
        },
       
        easing: 'linear', // [ 0.455, 0.030, 0.515, 0.955 ],
        duration: duration,
        delay: delay
      }).finished;

    }
  }



}

for (var el of document.querySelectorAll('.smoke')) {

  var stack = new SmokeStack(el);

  stack.start();
}

