class NavigationController { 
  constructor() {
    this.view = views[1];
  }

  async next() {
    if (this.view.index === views.length - 1) {
      // console.log('end');
      return;
    }

    // unload the current view
    await this.view.onUnload();

    this.view = views[this.view.index + 1];

    await this.view.onLoad();
  }
  
  async prev() {
    if (this.view.index === 0) {
      // console.log('start');
      return
    }

    // unload the current view
    if (this.view.onUnload) {
      await this.view.onUnload();
    }

    this.view = views[this.view.index - 1];

    // await app.navigate({ url: this.view.path });

    // load the new view
    await this.view.onLoad();
  }
}

var reverse = false;

var nav = new NavigationController();

document.addEventListener('keydown', async function(e) {

  if (document.activeElement) {
    // TODO: check if they've inputed anything
  }
  
  switch (e.which) {
      case 37: // left
      
        if (!reverse) {
          reverse = true;

          anime({
            targets: "#ship",
            scaleX: {
              value: -1
            }
          });
        }
        
        nav.prev();

       

      break;

      case 38: // up
        // app.navigate({ url: '/development' });
        break;

      case 39: // right
      
      if (reverse) {

        reverse = false;

        await anime({
          targets: "#ship",
          scaleX: {
            value: 0
          }
        }).finished;
      }
        
      nav.next();

       

      break;

      case 40: // down
        // app.navigate({ url: '/activity' });
      break;

      default: return; // exit this handler for other keys
  }

  e.preventDefault();
});
