let viewEl = document.querySelector('.view');

View.get('intro').loadActions.push(function() {
  // world.pan(world.scenes[0].position);
  
  viewEl.innerHTML = '';
});

View.get('signin').loadActions.push(function() {
  world.pan(world.scenes[1].position);

  loadView('signin');
});

View.get('authorize').loadActions.push(async function(e) {
  world.pan(world.scenes[2].position);
  return await loadView(e);
});

View.get('agreement').loadActions.push(function(e) {
  world.pan(world.scenes[3].position);




  loadView(e);

  setTimeout(() => {

    let flagEl = document.getElementById('flag');

    lottie.loadAnimation({
      container: flagEl,
      renderer: 'svg',
      loop: true,
      autoplay: true,
      animationData: flagAnimationData
    });
  }, 500);

  
});

View.get('setup').loadActions.push(function(e) {
  world.pan(world.scenes[4].position);

  loadView(e);
});

View.get('outro').loadActions.push(function() {
  world.pan(world.scenes[5].position);

  world.fadeOut();

  viewEl.innerHTML = 'HELLO!!!!';
  viewEl.innerHTML = '';
});

console.log('LOADED');

var viewAnimaton;


(function() {
  for (var name of [ 'signin', 'authorize', 'agreement', 'setup' ]) {

    let view = View.get(name);

    view.unloadActions.push(function(e) {

      console.log('unloading', e);

      viewAnimaton = anime({
        targets: viewEl,
        translateX: [ 0, -50 ],
        opacity: 0,
        duration: 300,
        delay: 0,
        easing: [0.7, 0.0, 0.38, 1.0 ]
      });
      
    });
  }
})();


async function loadView(e, delay = 300) {
  console.log('loading', e);

  if (e.name == 'undefined') return;
  
  var html = await fetch('/views/' + e.name).then(result => result.text());

  setTimeout(async function() {
    viewEl.innerHTML = html;

    let formEl = document.querySelector('.view form');

    if (formEl) {
      new Carbon.Form(formEl);
    }
  }, delay);

  if (viewAnimaton) {
    await viewAnimaton.finished;
  }

  viewAnimaton = anime({
    targets: viewEl,
    translateX: [ 25, 0],
    opacity: 1,
    duration: 400,
    delay: delay,
    easing: [ 0.7, 0.0, 0.38, 1.0 ]
  });

  console.log('asfasdf');

 
  
  
  // viewEl.classList.add('show');

  // https://transporter.staged.ai/views/signin

}

loadView({ name: 'signin' }, 0);


class World {
  constructor() {
    this.element = document.querySelector('.world');
    this.background = new Plane('background');
    this.midground = new Plane('midground');
    this.foreground = new Plane('foreground');   

    this.control = new Carbon.Form(document.querySelector('#scenes'))

    this.position2 = document.querySelector('#position2');

    this.position2.addEventListener('input', e => {
      
      this.instant = true;

      this.pan(e.target.value);

      this.instant = false;
    });

    this.control.on('field:change', e => {
     this.sync();
    });

    this.scenes = [ 
      { name: 'intro', position: 0 },
      { name: 'signin', position: 0 },
      { name: 'authorize', position: 0 },
      { name: 'agreement', position: 0 },
      { name: 'setup', position: 0 },
      { name: 'outro', position: 0 }
    ];

    this.sync();
  }

  async fadeIn() {
    this.instant = true;
    
    this.pan(0.2);

    this.instant = false;

    this.element.classList.add('fadeIn');
  }

  fadeOut() {
    this.element.classList.add('fadeOut');
  }

  sync() {
    for (var i = 0; i < this.control.fields.length; i++) {
      
      let field = this.control.fields[i];

      this.scenes[i].position = parseFloat(field.value);
    }

    console.log(this.scenes);
  }

  updatePosition(e) {
    this.pan(e.value);
  }

  updateDuration(e) {
    this.background.duration = parseInt(e.value);
    this.midground.duration = parseInt(e.value);
    this.foreground.duration = parseInt(e.value);
  }

  async pan(percent) {
    document.querySelector('#position').value = percent;
    document.querySelector('#position2').value = percent;

    
      this.background.moveTo(this.background.width * percent);
      this.midground.moveTo(this.midground.width * percent);
      this.foreground.moveTo(this.foreground.width * percent);

      setTimeout(function() {

        viewEl.classList.remove('hide');
      }, 600);
   

  
  }
}

class Plane {
  constructor(name, options) {
    this.name = name;
    this.element = document.querySelector('.plane.' + name);

    this.width = this.element.getBoundingClientRect().width;
    this.frameWidth = document.body.getBoundingClientRect().width;

    let formEl = document.querySelector('#' + name + '_parameters');

    /*
    this.control = new Carbon.Form(formEl)

    this.control.on('field:change', e => {      
     this.sync();
    });
    */

    this.duration = 5000;

    this.sync();
  }

  sync() {
    /*
    var data = this.control.serialize(); 

    for (var key of Object.keys(data)) {
      this[key] = parseInt(data[key]);
    }
    */
    // this.element.style.left = this.x + 'px';
    // this.element.style.top = this.y + 'px';
  }

  async moveTo(x) {
    this.width = this.element.getBoundingClientRect().width;

    if (this.running) {
      this.animation.pause();
    }

    let d = this.duration;

    if (world.instant) {
      d = 0;
    }

    this.animation = anime({
      targets: this.element,
      duration: d,
      easing: "easeOutQuart",
      translateX: -x,
    });

    this.running = true;

    await this.animation.finished;

    this.running = false;
  }
}

let world = new World();

world.fadeIn();