class Bridge {
  // inbox
  // output?

  watchOne(type) {
    this.defer = new Deferred();
    
    return this.defer;

  }
  receive(message) {
    // console.log('recieved', message);
    
    if (this.defer) {
      this.defer.resolve(message);
      this.defer = null;
    }

    if (message.type) {
      console.log('trigger:' + message.type);

      reactive.trigger(message);
    }

    if (message.type == 'selectedDirectory') {

      var form = document.querySelector('form');

      if (form) {
        Carbon.Form.get(form).fields[0].value = message.path; 
      }
    }

    // validationErrors
  }
  
  invoke(type, data) {
    let message = {
      method    : type,
      arguments : data
    };

    window.webkit.messageHandlers.bridge.postMessage(message);
  }
}

reactive.on('client:updated', e=> {
  var el = document.querySelector('.sidebar li');

  el.click();
});

reactive.on('site:created', e => {
  console.log('site created', e);

  app.navigate({ url: '/organization' });
});

reactive.on('user:authorized', e => {
  console.log('user:authorized', e);

  document.body.classList.add('authorized');

  if (!e.AgreedToTerms) {
    app.navigate({ url: '/agreement' });
  }
  else {
    app.navigate({ url: '/setup' });
  }

  setTimeout(function() {
    app.sidebar.render();
  }, 1000);

});


reactive.on('user:agreedToTerms', e => {
  app.navigate({ url: '/setup' });
});

reactive.on('stylesheet:changed', e => {
  console.log('stylesheet', e.path);

  for (var linkEl of document.querySelectorAll('link')) {
    if (linkEl.href && linkEl.href.indexOf(e.path) > -1) {
      if (!linkEl.dataset['original']) {
        linkEl.dataset['original'] = linkEl.href;
      }

      var newHref = linkEl.dataset['original'] + '?bust=' + Date.now();

      linkEl.href = newHref;
    }
  }
});

var bridge = new Bridge();

bridge.invoke('changeStatus', 'ready');

function renderPartial(html) {
  let mainEl = document.querySelector('main');

  mainEl.innerHTML = html;

  this.onDomChange();
}

function debug(message) {
  let debugEl = document.getElementById('debug');

  if (debugEl) {
    debugEl.innerHTML = JSON.stringify(message || 'unknown');
  }
}

function onDomChange() {
  // Wire up the forms
  for (var formEl of document.querySelectorAll('form')) {
    if (formEl.classList.contains('setup')) return;

    let form = new Carbon.Form(formEl);

    form.managed = true;

    form.on('submit', async e => {
      let f = Carbon.Form.get(e.target);

      f.validate().then(
        () => app.handleFormSubmit(f),
        (errors) => { 
          console.log('rejected', errors);
        }
      );
    });
  }
}

onDomChange();