class View {
  static get(name) {
    return viewMap.get(name);
  }
  constructor(index, name) {
    this.index = index;
    this.name = name;
    this.path = '/' + name;
    
    this.loadActions = [ ];
    this.unloadActions = [ ];
  }

  async onLoad() { 
    for (var action of this.loadActions) {
      
      console.log('X', this, action);

      var result = action(this);

      if (typeof result === "object" && 'then' in result) {
        await result;
      }
    }
  }

  async onUnload() {
    for (var action of this.unloadActions) {
      var result = action(this);

      if (typeof result === "object" && 'then' in result) { 
        await result;
      }
    }
  }
}

let views = [
  new View(0, 'intro'),
  new View(1, 'signin'),
  new View(2, 'authorize'),
  new View(3, 'agreement'),
  new View(4, 'setup'),
  new View(5, 'outro')
];

let viewMap = new Map();

for (var view of views) {
  viewMap.set(view.name, view);
}