{#repository}
<AppBar(title: "{organization.name} / {repository.name}", backLink: "/organization")>

  <div class="actions">
    <Icon(name: "reload", width: 20, height: 20, onclick: "new RepositoryComponent({id}).check()") />
  </div>
</AppBar>

<div class="guts">

  <p>PATH | {path}</p>
  
  <section>

    <button onclick="new RepositoryComponent({id}).fetch(this)">fetch</button>

    {#if localChanges.count > 0}
    <button onclick="new RepositoryComponent({id}).push(this)">push {localChanges.count}</button>
    {/if}

    {#if remoteChanges.count > 0}
    <button onclick="new RepositoryComponent({id}).pull(this)">pull {remoteChanges.count}</button>
    {/if}

    {#if remoteChanges.count > 0}
    <div style="border:1px solid #ccc;padding:15px;margin-bottom:10px;">
      <p>Remote changes</p>
      {#for file in remoteChanges.items}
      <p>{file.status}: {file.key} | {file.size} | {file.authorId}</p>
      {/for}
    </div>
    {/if}

    {#if localChanges.count > 0}
    <div style="border:1px solid #ccc;padding:15px;">
      <p>Local changes</p>

      {#for file in localChanges.items}
      <p>{file.status}: {file.key} | {file.size} | {file.authorId}</p>
      {/for}
    </div>
    {/if}

  </section>
  <ul class="collaborators">
    {#collaborators}
    <li><Avatar (image: image) /> </li>
    {/collaborators}

    <li class="add">
      <Icon (name: "add", width: 15, height: 15) /> 
    </li>

    <li style="display:none;">
      <form action="addCollaborator">
          <Field (name: "email", type: "email", placeholder: "Email", required: true) />
    
          <button>Add collaborator</button>
    
          <div class="processingGuts">
            Adding collaborator
          </div>
        </form>
    </li>
  </ul>

  <h3>
    {name} {#head}<span class="head">{name}</span>{/head} 
  </h3>
  
  <div (dataId: id) id="repository_{id}" class="repository {if(isInitialized, "initialized")}" >    
    

    {#if !isInitialized}
    <form action="initializeRepository">
      <input type="hidden" name="id" value="{id}" />
      <button>initialize</button>
    </form>
    {/if}
    
    <Changeset />
</div>
{/repository}